// IntraTaskListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "nitra.h"
#include "IntraTaskListCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIntraTaskListCtrl

CIntraTaskListCtrl::CIntraTaskListCtrl(tIntraTaskQueue &queue) : m_tasks(queue)
{
	m_BrushProcess.CreateSolidBrush(RGB(0,200,0));
	m_BrushComplete.CreateSolidBrush(RGB(150,255,150));
	m_BrushOther.CreateSolidBrush(RGB(220,255,220));

	m_ProgressBoundsPen.CreatePen(PS_SOLID, 1, RGB(250, 255, 200));
	m_ProgressBounds2Pen.CreatePen(PS_SOLID, 1, RGB(173, 255, 4));

	m_szSpeedFace = "Mbps";
}

CIntraTaskListCtrl::~CIntraTaskListCtrl()
{
}


BEGIN_MESSAGE_MAP(CIntraTaskListCtrl, CListCtrl)
	//{{AFX_MSG_MAP(CIntraTaskListCtrl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIntraTaskListCtrl message handlers

void CIntraTaskListCtrl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	CDC paintDC; paintDC.Attach(lpDrawItemStruct->hDC);
	UINT uDrawTextFlags = DT_SINGLELINE | DT_WORD_ELLIPSIS;

	CString		text; 
	CRect		itemRect, prgRect;
	int			iTextWidth;

	CBrush m_BrushBk;
	m_BrushBk.CreateSolidBrush(GetBkColor());

	for(int i = 0; i < m_tasks.size(); i++)
	{
	//   
	//
	GetSubItemRect(i, 0, 0, itemRect);

	paintDC.FillRect(&itemRect, &m_BrushBk);

	//   
	//
	CIntraTask::_task_state state = m_tasks[i].oldState;

	if(state == CIntraTask::DELETED) continue;

	//   
	//
	int uState = GetItemState(i, LVIS_SELECTED);

	if((uState & LVIS_SELECTED) == LVIS_SELECTED)
		paintDC.SetTextColor(RGB(0, 0, 206));
	else
		paintDC.SetTextColor(RGB(0, 0, 0));
	
	// (0)   
	//
	GetSubItemRect(i, 0, 0, itemRect);
	
	itemRect.left += 2;
	itemRect.right = itemRect.left + GetColumnWidth(0);

	paintDC.DrawText(m_tasks[i].displayName, &itemRect, 
		uDrawTextFlags);

	// (1)  
	//
	float per = m_tasks[i].offset;
	per = per / m_tasks[i].dwFileSize;
	per = per * 100;

	if(state == CIntraTask::COMPLETE)
		per = 100.0;

	text.Format("%.1f%%", 100.0);
	iTextWidth = GetStringWidth(text);

	text.Format("%.1f%%", per);

	GetSubItemRect(i, 1, 0, itemRect);
	prgRect = itemRect;

	paintDC.FillRect(&itemRect, &m_BrushBk);

	prgRect.right -= iTextWidth + 25;

	prgRect.DeflateRect(2, 1, 2, 1);

	//   
	//
	CGdiObject *pOld = paintDC.SelectObject(&m_ProgressBoundsPen);

	paintDC.Rectangle(&prgRect);

	prgRect.DeflateRect(1, 1, 1, 1);

	paintDC.SelectObject(&m_ProgressBounds2Pen);

	paintDC.Rectangle(&prgRect);

	prgRect.DeflateRect(1, 1, 1, 1);

	prgRect.right = prgRect.left + (prgRect.right - prgRect.left) * (per / 100.0);

	// 
	//
	if(state == CIntraTask::DOWNLOAD ||  state == CIntraTask::READY)
	{
		paintDC.FillRect(&prgRect, &m_BrushProcess);
	}
	else if(state == CIntraTask::COMPLETE)
	{
		paintDC.FillRect(&prgRect, &m_BrushComplete);
	}
	else
	{
		paintDC.FillRect(&prgRect, &m_BrushOther);
	}

	// 
	//
	itemRect.left += (itemRect.right - itemRect.left) - iTextWidth - 5;

	paintDC.DrawText(text, &itemRect, uDrawTextFlags);

	paintDC.SelectObject(pOld);

	// (2)  
	//
	GetSubItemRect(i, 2, 0, itemRect);

	if(state != CIntraTask::COMPLETE) 
	{
		text.Format("%.1f %s", m_tasks[i].dwSpeed, m_szSpeedFace);

		iTextWidth = GetStringWidth(text);

		itemRect.left += (itemRect.right - itemRect.left) - iTextWidth - 5;

		paintDC.DrawText(text, &itemRect, uDrawTextFlags);
	}

	// (3)     
	//
	GetSubItemRect(i, 3, 0, itemRect);

	text.Format("%d bytes", m_tasks[i].offset);

	itemRect.left += 2;

	paintDC.DrawText(text, &itemRect, uDrawTextFlags);

	// (4)  
	//
	GetSubItemRect(i, 4, 0, itemRect);

	itemRect.left += 2;

	paintDC.DrawText(m_tasks[i].sourcePath, &itemRect, uDrawTextFlags);

	// (5)  
	//
	GetSubItemRect(i, 5, 0, itemRect);

	itemRect.left += 2;

	paintDC.DrawText(m_tasks[i].downloadPath, &itemRect, uDrawTextFlags);
	}

}

CString CIntraTaskListCtrl::DeflateString(int iCol, CString text)
{
	return text;
}
