// OptionsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "nitra.h"
#include "OptionsDlg.h"
#include "shellOpenFolder.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg dialog


COptionsDlg::COptionsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionsDlg)
	//}}AFX_DATA_INIT

}


void COptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsDlg)
	DDX_Control(pDX, IDC_EDIT_FOLDER, m_Folder);
	DDX_Control(pDX, IDC_OPTIONS, m_opt);
	//}}AFX_DATA_MAP

	if(!pDX->m_bSaveAndValidate)
	{
		CImageList list;

	// set the image list

		list.Create(IDB_OPTIONS_BMPS,16,1,RGB(255,0,255));
		m_opt.SetImageList(list);

		getOptions();

	// interface group
		m_opt.AddGroup(IDS_OPT_INTERFACE,0,0);
	
		m_opt.AddCheck(IDS_OPT_INTERFACE_SAVEPOS, 
			(m_lOptions & IDO_SAVEPOSITION) == IDO_SAVEPOSITION, 1);
		m_opt.AddCheck(IDS_OPT_INTERFACE_SAVECOLUMS, 
			(m_lOptions & IDO_SAVEWIDTH) == IDO_SAVEWIDTH, 1);
		m_opt.AddCheck(IDS_OPT_INTERFACE_MINIMIZE, 
			(m_lOptions & IDO_MINIMIZEINTRAY) == IDO_MINIMIZEINTRAY, 1);
		m_opt.AddCheck(IDS_OPT_INTERFACE_ALWAYSONTOP, 
			(m_lOptions & IDO_ALWAYSONTOP) == IDO_ALWAYSONTOP, 1);

		m_opt.AddGroup(IDS_OPT_SPEED,1,1);

		m_opt.AddRadio(IDS_OPT_SPEED_MBS, 
			(m_lOptions & IDO_SPEED_MBPS) == IDO_SPEED_MBPS, 2);
		m_opt.AddRadio(IDS_OPT_SPEED_KBS, 
			(m_lOptions & IDO_SPEED_KBPS) == IDO_SPEED_KBPS, 2);

		m_opt.AddGroup(IDS_OPT_DOWNLOAD,0,2);
		m_opt.AddGroup(IDS_OPT_DOWNLOAD_RECONNECT,1,3);

		m_opt.AddRadio(IDS_OPT_DOWNLOAD_RECONNECT_5, 
			(m_lOptions & IDO_RECONNECT_5) == IDO_RECONNECT_5, 2);
		m_opt.AddRadio(IDS_OPT_DOWNLOAD_RECONNECT_20, 
			(m_lOptions & IDO_RECONNECT_30) == IDO_RECONNECT_30, 2);
		m_opt.AddRadio(IDS_OPT_DOWNLOAD_RECONNECT_60, 
			(m_lOptions & IDO_RECONNECT_60) == IDO_RECONNECT_60, 2);
	}
}

BEGIN_MESSAGE_MAP(COptionsDlg, CDialog)
	//{{AFX_MSG_MAP(COptionsDlg)
	ON_BN_CLICKED(IDC_BTN_FOLDER, OnBtnFolder)
	ON_WM_CLOSE()
	ON_NOTIFY(OPN_SELCHANGE,IDC_OPTIONS,OnOptionsSelChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg message handlers
BOOL COptionsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_Folder.SetWindowText(getDownloadFolder());

	return TRUE;
}


void COptionsDlg::OnBtnFolder() 
{
	CString text = getDownloadFolder();

	CShellOpenFolder of;

	if(of.OpenFolderDlg(text, GetSafeHwnd()))
	{
		m_Folder.SetWindowText(text);

		reg.SetUserEntry(REG_APP, REG_DOWNLOADFOLDER, text);
	}
}

void COptionsDlg::OnOptionsSelChange(NMHDR *pNMHDR,LRESULT *pResult)
{
	NMOPTIONSPANEL *pInfo=(NMOPTIONSPANEL *)pNMHDR;
	CString					strReport;

	switch(pInfo->idButton)
	{
	case IDS_OPT_INTERFACE_SAVEPOS:

		if(pInfo->bChecked)
			m_lOptions = m_lOptions | IDO_SAVEPOSITION;
		else
			m_lOptions = m_lOptions & ~IDO_SAVEPOSITION;

		break;

	case IDS_OPT_INTERFACE_SAVECOLUMS:

		if(pInfo->bChecked)
			m_lOptions = m_lOptions | IDO_SAVEWIDTH;
		else
			m_lOptions = m_lOptions & ~IDO_SAVEWIDTH;

		break;

	case IDS_OPT_INTERFACE_MINIMIZE:

		if(pInfo->bChecked)
			m_lOptions = m_lOptions | IDO_MINIMIZEINTRAY;
		else
			m_lOptions = m_lOptions & ~IDO_MINIMIZEINTRAY;

		break;

	case IDS_OPT_SPEED_MBS:

		if(pInfo->bChecked)
			m_lOptions = m_lOptions | IDO_SPEED_MBPS;
		else
			m_lOptions = m_lOptions & ~IDO_SPEED_MBPS;

		break;

	case IDS_OPT_SPEED_KBS:

		if(pInfo->bChecked)
			m_lOptions = m_lOptions | IDO_SPEED_KBPS;
		else
			m_lOptions = m_lOptions & ~IDO_SPEED_KBPS;

		break;

	case IDS_OPT_DOWNLOAD_RECONNECT_5:

		if(pInfo->bChecked)
			m_lOptions = m_lOptions | IDO_RECONNECT_5;
		else
			m_lOptions = m_lOptions & ~IDO_RECONNECT_5;

		break;

	case IDS_OPT_DOWNLOAD_RECONNECT_20:

		if(pInfo->bChecked)
			m_lOptions = m_lOptions | IDO_RECONNECT_30;
		else
			m_lOptions = m_lOptions & ~IDO_RECONNECT_30;

		break;

	case IDS_OPT_DOWNLOAD_RECONNECT_60:

		if(pInfo->bChecked)
			m_lOptions = m_lOptions | IDO_RECONNECT_60;
		else
			m_lOptions = m_lOptions & ~IDO_RECONNECT_60;

		break;

	case IDS_OPT_INTERFACE_ALWAYSONTOP:

		if(pInfo->bChecked)
			m_lOptions = m_lOptions | IDO_ALWAYSONTOP;
		else
			m_lOptions = m_lOptions & ~IDO_ALWAYSONTOP;

		break;
	}

	reg.SetUserEntry(REG_APP, REG_OPTIONS, m_lOptions);
}

LONG COptionsDlg::getOptions()
{
	m_lOptions = IDO_SAVEPOSITION | IDO_SAVEWIDTH |
				 IDO_MINIMIZEINTRAY | IDO_SPEED_MBPS | IDO_RECONNECT_5;
	
	reg.GetUserEntry(REG_APP, REG_OPTIONS, m_lOptions);

	return m_lOptions;
}

CString COptionsDlg::getDownloadFolder()
{
	CString folder;

	reg.GetUserEntry(REG_APP, REG_DOWNLOADFOLDER, folder);

	return folder;
}

void COptionsDlg::OnClose() 
{
	CDialog::OnClose();
}

void COptionsDlg::OnOK() 
{
	CString pth; m_Folder.GetWindowText(pth);

	reg.SetUserEntry(REG_APP, REG_DOWNLOADFOLDER, pth);
	
	CDialog::OnOK();
}
