// ShellOpenFolder.cpp: implementation of the CShellOpenFolder class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "shlobj.h"
#include "ShellOpenFolder.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CShellOpenFolder::CShellOpenFolder()
{

}

CShellOpenFolder::~CShellOpenFolder()
{

}

int CALLBACK BrowseCallbackProc(HWND hwnd, UINT uMsg, 
								LPARAM lParam, LPARAM lpData)
{
	switch(uMsg) {
	case BFFM_INITIALIZED:
		SendMessage(hwnd, BFFM_SETSELECTION, FALSE, lpData);
		break;
	}
	return 0;
}

bool CShellOpenFolder::OpenFolderDlg(CString &path, HWND hwndParent)
{
	LPMALLOC pMalloc = NULL;
	BROWSEINFO bi;
	LPTSTR lpBuffer;
	LPITEMIDLIST pidlBrowse = NULL, pidlParent = NULL;

	if(!SUCCEEDED(SHGetMalloc(&pMalloc)))
		return false;

	if((lpBuffer = (LPTSTR) pMalloc->Alloc(MAX_PATH)) == NULL)
		return false;

	__try {
		ULONG nLength = 0;
		ULONG dwAttributes = 0;
		IShellFolder *piFolder = NULL;

		if(SHGetDesktopFolder(&piFolder) == NOERROR) 
		{
			WCHAR *oleName = path.AllocSysString();

			MultiByteToWideChar(CP_OEMCP, MB_COMPOSITE, 
				(LPCSTR) (LPCTSTR) path, path.GetLength(), oleName, MAX_PATH - 1);

			piFolder->ParseDisplayName(NULL, NULL,
				oleName, &nLength, &pidlParent, &dwAttributes);

			::SysFreeString(oleName);
		}

		bi.pidlRoot = NULL;
		bi.hwndOwner = hwndParent;
		bi.pszDisplayName = lpBuffer;
		bi.lpszTitle = _T("Select folder to download files:");
		bi.ulFlags = 0;
		bi.lpfn = BrowseCallbackProc;
		bi.lParam = (LPARAM) pidlParent;

		pidlBrowse = SHBrowseForFolder(&bi);
		if(piFolder) piFolder->Release();

		if(!pidlBrowse)
			return false;
		if(SHGetPathFromIDList(pidlBrowse, lpBuffer))
			path = lpBuffer;
		else 
			return false;
	}
	__finally {
		pMalloc->Free(pidlBrowse);
		pMalloc->Free(lpBuffer);
	}
	return true;
}
