// nitra.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "nitra.h"
#include "nitraDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

////////////////////////////////////////////////////////////////////////////
//
#pragma data_seg("Shared")

	ULONG		g_Instances = 0;	//    
	DWORD		g_mainThreadId = 0;

#pragma data_seg()

#pragma comment(linker, "/section:Shared,rws")

#define TM_ADDTASKS		WM_USER + 2005

#define MAPFILENAME		"{5F474820-9FE0-48df-AD98-224EF79F41B1}"
#define MAPFILESIZE		64 * 1024

CRegistry reg;

/////////////////////////////////////////////////////////////////////////////
// CNitraApp

BEGIN_MESSAGE_MAP(CNitraApp, CWinApp)
	//{{AFX_MSG_MAP(CNitraApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
	ON_MESSAGE(TM_ADDTASKS, OnAddTasks)
END_MESSAGE_MAP()

void split(CString what, std::vector<CString> &array, CString delimeter = _T(","))
{
	int i_index = 0;
	int i_next = 0;

	CString s_item;

	while(i_index <= what.GetLength())
	{
		i_next = what.Find(delimeter, i_index);
		if(i_next < 0) i_next = what.GetLength();

		s_item = what.Mid(i_index, i_next - i_index);

		s_item.TrimLeft(); s_item.TrimRight();
		//s_item.MakeLower();

		if(s_item != "") array.push_back(s_item);

		i_index = i_next + 1;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CNitraApp construction

CNitraApp::CNitraApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CNitraApp object

CNitraApp theApp;

// Parse parameters class
//
class CNitraCmdLineInfo: public CCommandLineInfo
{
public:
	std::vector<CString> m_Tasks;
	CString				 m_dstFolder;
	int					 iNum;

public:
	CNitraCmdLineInfo(void) : CCommandLineInfo(), iNum(0) {;}

	virtual void ParseParam( LPCTSTR lpszParam, BOOL bFlag, BOOL bLast )
	{
		//  
		//
		CString files = lpszParam;

		int iPos = 0, iLastPos = 0, length = files.GetLength();

			if(files[0] == '\"') {
				iLastPos = iPos = 1;
			}

			if(files[length - 1] == '\"') {
				length--;
			}

			if(files[length - 1] == ';') {
				length--;
			}

		if(iNum == 1)
		{
			m_dstFolder = files.Mid(iPos, length - iPos);
		}
		else
		{

			split(files.Mid(iPos, length - iPos), m_Tasks, ';');
		}

		iNum++;

     CCommandLineInfo::ParseParam( lpszParam, bFlag, bLast);
	}
};

/////////////////////////////////////////////////////////////////////////////
// CNitraApp initialization

BOOL CNitraApp::InitInstance()
{
	log.Init();

	OleInitialize(NULL);

	//   
	//
	CNitraCmdLineInfo cmdInfo;

	ParseCommandLine(cmdInfo);

	//     
	//
	InterlockedIncrement((PLONG) &g_Instances);

	if(g_Instances > 1) 
	{
		//   
		//
		HANDLE hFileMap = ::OpenFileMapping(FILE_MAP_WRITE, FALSE, 
			MAPFILENAME);

		if(hFileMap == NULL) return FALSE;

		//      
		//  
		//
		LPVOID lpView = ::MapViewOfFile(hFileMap, FILE_MAP_WRITE, 0, 0, 0);

		if(!lpView) return FALSE;

		//     
		//
		memset(lpView, 0, MAPFILESIZE);

		//     
		//
		memcpy(lpView, m_lpCmdLine, strlen(m_lpCmdLine));

		//  
		//
		UnmapViewOfFile(lpView);

		CloseHandle(hFileMap);

		//     
		//
		::PostThreadMessage(g_mainThreadId, TM_ADDTASKS, 0, 0);

		return FALSE;
	}

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	g_mainThreadId = GetCurrentThreadId();

	//     
	//
	m_hFileMap = ::CreateFileMapping((HANDLE) 0xFFFFFFFF, NULL, PAGE_READWRITE,
		0, 64 * 1024, MAPFILENAME);

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	CNitraDlg dlg;

	dlg.parms.m_tasks = cmdInfo.m_Tasks;
	dlg.parms.downloadPath = cmdInfo.m_dstFolder;

	m_pMainWnd = &dlg;

	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	CloseHandle(m_hFileMap);

	InterlockedDecrement((PLONG) &g_Instances);

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

int CNitraApp::ExitInstance() 
{
	OleUninitialize();
	
	return CWinApp::ExitInstance();
}

void CNitraApp::OnAddTasks(WPARAM wParam, LPARAM lParam)
{
	//     
	//  
	//
	if(m_hFileMap == NULL) return;

	LPVOID lpView = ::MapViewOfFile(m_hFileMap, FILE_MAP_READ, 0, 0, 0);

	if(!lpView) return;

	//     
	//
	CString data = (LPCSTR) lpView;

	//      
	//
	CNitraCmdLineInfo cmdInfo;

	std::vector<CString> args;

	split(data, args, "\" \"");

	for(int i = 0; i < args.size(); i++)
	{
		cmdInfo.ParseParam(args[i], FALSE, FALSE);
	}

	CNitraDlg *pDlg = (CNitraDlg *) m_pMainWnd;

	pDlg->addTasks(cmdInfo.m_Tasks, cmdInfo.m_dstFolder);

	//  
	//
	UnmapViewOfFile(lpView);
}
