// nitraDlg.h : header file
//

#if !defined(AFX_NITRADLG_H__36065D22_8C17_444D_AAFE_E0449C09B427__INCLUDED_)
#define AFX_NITRADLG_H__36065D22_8C17_444D_AAFE_E0449C09B427__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../common/intradownloader.h"
#include "intraTaskListCtrl.h"
#include "OptionsDlg.h"
#include "SystemTray.h"

struct sParameters
{
	std::vector<CString> m_tasks;
	CString downloadPath;
};

/////////////////////////////////////////////////////////////////////////////
// CNitraDlg dialog

class CNitraDlg : public CDialog, public CIntraDownloaderListener
{

	COptionsDlg m_OptionsDlg;
	CSystemTray m_TrayIcon;

// Construction
public:
	void setupOptions();
	void loadOptions();
	void saveOptions();
	int GetTaskListSelectedItem();
	sParameters parms;

	void addTasks(std::vector<CString> &tasks, CString szDownloadPath);
	CNitraDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CNitraDlg)
	enum { IDD = IDD_NITRA_DIALOG };
	CIntraTaskListCtrl	m_taskList;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNitraDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL
	afx_msg BOOL OnToolTipText(UINT, NMHDR* pNMHDR, LRESULT* pResult);

	virtual void onStartDownload();
	virtual void onTaskStart(int nTask, CIntraTask &task);
	virtual void onTaskProcess(int nTask, CIntraTask &task);
	virtual void onTaskPaused(int nTask);
	virtual void onTaskComplete(int nTask);
	virtual void onTaskDelete(int nTask);
	virtual bool continueOnError(int errorCode);

	
	virtual bool isValid() { return ::IsWindow(m_hWnd) == 1 && 
									::IsWindow(m_taskList.m_hWnd) == 1; }

// Implementation
protected:
	CString DescribeState();
	//CWnd m_wndInvisible;
	HICON m_hIcon;
	CToolBar m_wndToolBar;

	// Generated message map functions
	//{{AFX_MSG(CNitraDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnMenuTaskResume();
	afx_msg void OnMenuTaskDelete();
	afx_msg void OnMenuTaskPause();
	afx_msg void OnMenuTaskStop();
	afx_msg void OnMenuTaskOpen();
	afx_msg void OnMenuTaskOpenFolder();
	afx_msg void OnMenuTaskOpenDestFolder();
	afx_msg void OnRclickList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClose();
	afx_msg void OnNcPaint();
	afx_msg void OnOptions();
	afx_msg void OnAddNewTasks();
	afx_msg void OnAddNewTasksFolder();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
	afx_msg void OnWindowPosChanging(WINDOWPOS FAR* lpwndpos);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	afx_msg void OnPopupAbout();
	afx_msg void OnPopupShow();
	afx_msg void OnPopupExit();
	afx_msg long OnPostStartDownload(WPARAM wParm, LPARAM lParm);

	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_NITRADLG_H__36065D22_8C17_444D_AAFE_E0449C09B427__INCLUDED_)
